unit uKoinzidenz;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    mEin: TMemo;
    bAnalysiere: TButton;
    mAus: TMemo;
    procedure bAnalysiereClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.bAnalysiereClick(Sender: TObject);
var
  text  : string;
  n,i   : integer;
  Ind,h : real;
  z     : array[0..255] of byte;
begin
  // Eingabe
  text := mEin.Text;

  // Vorbereitungen
  for i := 0 to 255 do z[i] := 0;

  // Zhlen
  for i := 0 to Length(text) do inc(z[ord(upcase(text[i]))]); // upcase !

  // Buchstaben zhlen
  n := 0;
  for i := 65 to 90 do n := n + z[i]; // A .. Z

  // Koinzidenzindex Ind berechnen
  Ind := 0;
  for i := 65 to 90 do Ind := Ind + sqr(z[i]/n);

  // Schlsselwortlnge h berechnen
  h := 0.0377*n/(Ind*(n-1)-0.0385*n+0.0762);

  // Ausgabe
  mAus.Lines.Add('Koinzidenz-Index = '+FloatToStr(Ind));
  mAus.Lines.Add('h = '+FloatToStr(h));
end;

end.
